var ft = Object.defineProperty;
var ht = (s, t, e) => t in s ? ft(s, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : s[t] = e;
var B = (s, t, e) => (ht(s, typeof t != "symbol" ? t + "" : t, e), e), ve = (s, t, e) => {
  if (!t.has(s))
    throw TypeError("Cannot " + e);
};
var m = (s, t, e) => (ve(s, t, "read from private field"), e ? e.call(s) : t.get(s)), q = (s, t, e) => {
  if (t.has(s))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(s) : t.set(s, e);
}, H = (s, t, e, r) => (ve(s, t, "write to private field"), r ? r.call(s, e) : t.set(s, e), e);
var ye = (s, t, e) => (ve(s, t, "access private method"), e);
import { A as de, B as d, e as re, a as mt, c as oe, b as We } from "./app-automate-OgsZz9JB.js";
import E from "fs";
import { randomBytes as Ne } from "node:crypto";
import dt, { join as je, resolve as Je } from "node:path";
import { promisify as j } from "node:util";
import Me, { spawnSync as pt } from "node:child_process";
import { constants as Z, lstat as ie, mkdir as wt, chmod as gt, unlink as Fe } from "node:fs/promises";
import { homedir as vt, tmpdir as yt } from "node:os";
class kt extends de {
  /**
   * Constructs a new instance of the AutomateClient class.
   * @param options - Options to customize the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Recycles the automate key.
   * @param options The fetch options for the request.
   * @returns {} A promise that resolves to the response of the request.
   */
  recycleKey(t) {
    return this.makePutRequest("/automate/recycle_key.json", t);
  }
  /**
   * Retrieves the automate plan.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the automate plan.
   */
  getPlan(t) {
    return this.makeGetRequest("/automate/plan.json", t);
  }
  /**
   * Retrieves the list of available browsers for BrowserStack Automate.
   * @param options - Optional fetch options for customizing the request.
   * @returns A Promise that resolves to the list of available browsers.
   */
  getBrowsers(t) {
    return this.makeGetRequest("/automate/browsers.json", t);
  }
  /**
   * Retrieves the projects from the BrowserStack Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects data.
   */
  getProjects(t) {
    return this.makeGetRequest("/automate/projects.json", t);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(t, e) {
    return this.makeGetRequest("/automate/projects/{projectId}.json", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      }
    }).then((r) => r.project);
  }
  /**
   * Updates a project with the specified ID.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project details.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project.
   */
  updateProject(t, e, r) {
    return this.makePutRequest("/automate/projects/{projectId}.json", {
      ...r,
      body: e,
      params: {
        path: {
          projectId: t
        }
      }
    });
  }
  /**
   * Deletes a project with the specified ID.
   * @param projectId The ID of the project to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(t, e) {
    return this.makeDeleteRequest("/automate/projects/{projectId}.json", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(t, e) {
    return this.makeGetRequest("/automate/projects/{projectId}/badge_key", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the BrowserStack Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A Promise that resolves to an array of automation builds.
   */
  getBuilds(t, e) {
    return this.makeGetRequest("/automate/builds.json", {
      ...e,
      params: {
        query: t
      }
    }).then((r) => r.map((i) => i.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the build information.
   */
  getBuild(t, e) {
    return this.makeGetRequest("/automate/builds/{buildId}.json", {
      ...e,
      params: {
        path: {
          buildId: t
        }
      }
    }).then((r) => ({
      ...r.build.automation_build,
      sessions: r.build.sessions.map(
        (i) => i.automation_session
      )
    }));
  }
  /**
   * Updates a build in the BrowserStack Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated build data.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(t, e, r) {
    return this.makePutRequest("/automate/builds/{buildId}.json", {
      ...r,
      body: e,
      params: {
        path: {
          buildId: t
        }
      }
    }).then((i) => {
      if ("error" in i)
        throw new d(i.error, { response: i });
      return i.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(t, e) {
    return this.makeDeleteRequest("/automate/builds/{buildId}.json", {
      ...e,
      params: {
        path: {
          buildId: t
        }
      }
    });
  }
  /**
   * Deletes multiple builds from the BrowserStack Automate API.
   * @param buildIds An array of build IDs to be deleted.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the delete request is successful.
   */
  deleteBuilds(t, e) {
    return this.makeDeleteRequest("/automate/builds", {
      ...e,
      params: {
        query: {
          "buildId[]": t
        }
      }
    });
  }
  /**
   * Retrieves the sessions associated with a specific build.
   *
   * @param buildId - The ID of the build.
   * @param query - Optional query parameters for filtering the sessions.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of automation sessions.
   */
  getSessions(t, e, r) {
    return this.makeGetRequest("/automate/builds/{buildId}/sessions.json", {
      ...r,
      params: {
        path: {
          buildId: t
        },
        query: e
      }
    }).then((i) => i.map((n) => n.automation_session));
  }
  /**
   * Retrieves the details of a specific session.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}.json", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    }).then((r) => r.automation_session);
  }
  /**
   * Updates an automate session.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated automation session.
   */
  updateSession(t, e, r) {
    return this.makePutRequest("/automate/sessions/{sessionId}.json", {
      ...r,
      body: e,
      params: {
        path: {
          sessionId: t
        }
      }
    }).then((i) => i.automation_session);
  }
  /**
   * Deletes a session by its session ID.
   * @param sessionId The ID of the session to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(t, e) {
    return this.makeDeleteRequest("/automate/sessions/{sessionId}.json", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    });
  }
  /**
   * Deletes the specified sessions.
   * @param sessionIds - An array of session IDs to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the delete request is complete.
   */
  deleteSessions(t, e) {
    return this.makeDeleteRequest("/automate/sessions", {
      ...e,
      params: {
        query: {
          "sessionId[]": t
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param data - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(t, e, r) {
    return this.makeCloudPostRequest(
      "/automate/builds/{buildId}/terminallogs",
      {
        ...r,
        body: e,
        bodySerializer: (i) => {
          const n = new FormData();
          return n.append("file", i.file, e.filename), n;
        },
        params: {
          path: {
            buildId: t
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param data - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(t, e, r) {
    return this.makeCloudPostRequest(
      "/automate/sessions/{sessionId}/terminallogs",
      {
        ...r,
        body: e,
        bodySerializer: (i) => {
          const n = new FormData();
          return n.append("file", i.file, e.filename), n;
        },
        params: {
          path: {
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the logs of the session.
   */
  getSessionLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/logs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the network logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/networklogs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    });
  }
  /**
   * Retrieves the console logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the console logs.
   */
  getSessionConsoleLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/consolelogs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the Selenium logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the Selenium logs.
   */
  getSessionSeleniumLogs(t, e) {
    return this.makeCloudGetRequest(
      "/automate/sessions/{sessionId}/seleniumlogs",
      {
        ...e,
        params: {
          path: {
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/appiumlogs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the telemetry logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the telemetry logs.
   */
  getSessionTelemetryLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/telemetrylogs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    });
  }
  /**
   * Uploads a media file to the BrowserStack Automate API.
   *
   * @param data - The content of the media file to be uploaded, along with its filename.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the response of the API request.
   */
  uploadMediaFile(t, e) {
    return this.makePostRequest("/automate/upload-media", {
      ...e,
      body: t,
      bodySerializer: (r) => {
        const i = new FormData();
        return i.append("file", r.file, t.filename), i;
      }
    });
  }
  /**
   * Retrieves the recent media files from the BrowserStack Automate API.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves with the response from the API.
   */
  getMediaFiles(t) {
    return this.makeGetRequest("/automate/recent_media_files", t);
  }
  /**
   * Deletes a media file.
   * @param mediaId The ID of the media file to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(t, e) {
    return this.makeDeleteRequest("/automate/custom_media/delete/{mediaId}", {
      ...e,
      params: {
        path: {
          mediaId: t
        }
      }
    });
  }
}
class He extends de {
  /**
   * Constructs a new instance of the JSTestingClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://api.browserstack.com/5"
    });
  }
  /**
   * Retrieves the account status.
   *
   * @returns A Promise that resolves to the account status.
   */
  getAccountStatus() {
    return this.makeGetRequest("/status");
  }
  /**
   * Retrieves a list of browsers from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of browsers.
   */
  getBrowsers(t, e) {
    return this.makeGetRequest("/browsers", {
      ...e,
      params: {
        query: {
          ...t,
          flat: typeof (t == null ? void 0 : t.flat) == "boolean" ? t.flat : !0
        }
      }
    });
  }
  /**
   * Creates a worker for JS testing.
   *
   * @param body - The request body.
   * @param options - The API fetch options.
   * @returns A promise that resolves to the worker response.
   */
  createWorker(t, e) {
    return this.makePostRequest("/worker", {
      ...e,
      body: t
    });
  }
  /**
   * Retrieves a list of workers.
   *
   * @param options - Optional parameters for the API request.
   * @returns A promise that resolves to an array of Worker objects.
   */
  getWorkers(t) {
    return this.makeGetRequest("/workers", t);
  }
  /**
   * Retrieves a worker by its ID.
   *
   * @param workerId The ID of the worker.
   * @param options Additional options for the API request.
   * @returns A Promise that resolves to the retrieved worker.
   */
  getWorker(t, e) {
    return this.makeGetRequest("/worker/{workerId}", {
      ...e,
      params: {
        path: {
          workerId: t
        }
      }
    });
  }
  /**
   * Deletes a worker by worker ID.
   *
   * @param workerId The ID of the worker to delete.
   * @param options Optional API fetch options.
   * @returns A promise that resolves when the worker is deleted.
   */
  deleteWorker(t, e) {
    return this.makeDeleteRequest("/worker/{workerId}", {
      ...e,
      params: {
        path: {
          workerId: t
        }
      }
    });
  }
  /**
   * Updates the URL of a worker.
   *
   * @param workerId - The ID of the worker.
   * @param body - The request body containing the updated URL.
   * @param options - Optional API fetch options.
   * @returns A promise that resolves with the response from the server.
   */
  updateWorkerURL(t, e, r) {
    return this.makePutRequest("/worker/{workerId}/url.json", {
      ...r,
      params: {
        path: {
          workerId: t
        }
      },
      body: e
    });
  }
  /**
   * Takes a screenshot of a worker.
   *
   * @param workerId - The ID of the worker.
   * @param format - The format of the screenshot (e.g., "png", "json", "xml").
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the screenshot data.
   */
  getWorkerScreenshot(t, e, r) {
    return this.makeGetRequest("/worker/{workerId}/screenshot.{format}", {
      ...r,
      params: {
        path: {
          workerId: t,
          format: e ?? "png"
        }
      },
      parseAs: e === "json" ? "json" : e === "xml" ? "text" : "arrayBuffer"
    });
  }
  /**
   * Awaits a worker with the specified workerId to attain "running" status.
   *
   * @param workerId - The ID of the worker to retrieve.
   * @param options - Optional API fetch options.
   * @param pollInterval - The interval (in milliseconds) at which to poll for the worker status. Default is 10000ms.
   * @returns A promise that resolves with the running worker.
   */
  ensureWorkerRunning(t, e, r = 1e4) {
    return new Promise((i, n) => {
      let a;
      const f = (c, h) => {
        var o;
        clearInterval(u), (o = a == null ? void 0 : a.abort) == null || o.call(a), c ? n(
          c instanceof d ? c : new d(c.message, c)
        ) : h && i(h);
      }, u = setInterval(async () => {
        a = e != null && e.signal ? void 0 : new AbortController();
        const c = await this.getWorker(t, {
          ...e,
          signal: (e == null ? void 0 : e.signal) ?? (a == null ? void 0 : a.signal)
        }).catch(f);
        c && (c.id ? c.status === "running" && f(void 0, c) : f(new d(`Worker ${t} is no longer running`)));
      }, r);
    });
  }
  /**
   * High-level abstraction for launching a worker-browser with the specified options.
   *
   * @param body The request body for creating the worker.
   * @param options The options for creating the worker.
   * @returns A promise that resolves to the launched worker.
   */
  async launch(t, e) {
    const { pollInterval: r, ...i } = e ?? {}, { id: n } = await this.createWorker(t, i), a = await this.ensureWorkerRunning(n, void 0, r), f = {
      ...a,
      updateURL: (u) => this.updateWorkerURL(a.id, { url: u }),
      getScreenshot: () => this.getWorkerScreenshot(a.id, "png"),
      getScreenshotURL: () => this.getWorkerScreenshot(a.id, "json").then((u) => u.url),
      terminate: async () => this.deleteWorker(a.id).then((u) => (f.status = void 0, u))
    };
    return f;
  }
}
var A = Uint8Array, Y = Uint16Array, St = Int32Array, Ye = new A([
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1,
  1,
  1,
  1,
  2,
  2,
  2,
  2,
  3,
  3,
  3,
  3,
  4,
  4,
  4,
  4,
  5,
  5,
  5,
  5,
  0,
  /* unused */
  0,
  0,
  /* impossible */
  0
]), Xe = new A([
  0,
  0,
  0,
  0,
  1,
  1,
  2,
  2,
  3,
  3,
  4,
  4,
  5,
  5,
  6,
  6,
  7,
  7,
  8,
  8,
  9,
  9,
  10,
  10,
  11,
  11,
  12,
  12,
  13,
  13,
  /* unused */
  0,
  0
]), xt = new A([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]), Ve = function(s, t) {
  for (var e = new Y(31), r = 0; r < 31; ++r)
    e[r] = t += 1 << s[r - 1];
  for (var i = new St(e[30]), r = 1; r < 30; ++r)
    for (var n = e[r]; n < e[r + 1]; ++n)
      i[n] = n - e[r] << 5 | r;
  return { b: e, r: i };
}, Qe = Ve(Ye, 2), Ze = Qe.b, Rt = Qe.r;
Ze[28] = 258, Rt[258] = 28;
var It = Ve(Xe, 0), Et = It.b, Ee = new Y(32768);
for (var w = 0; w < 32768; ++w) {
  var $ = (w & 43690) >> 1 | (w & 21845) << 1;
  $ = ($ & 52428) >> 2 | ($ & 13107) << 2, $ = ($ & 61680) >> 4 | ($ & 3855) << 4, Ee[w] = (($ & 65280) >> 8 | ($ & 255) << 8) >> 1;
}
var se = function(s, t, e) {
  for (var r = s.length, i = 0, n = new Y(t); i < r; ++i)
    s[i] && ++n[s[i] - 1];
  var a = new Y(t);
  for (i = 1; i < t; ++i)
    a[i] = a[i - 1] + n[i - 1] << 1;
  var f;
  if (e) {
    f = new Y(1 << t);
    var u = 15 - t;
    for (i = 0; i < r; ++i)
      if (s[i])
        for (var c = i << 4 | s[i], h = t - s[i], o = a[s[i] - 1]++ << h, l = o | (1 << h) - 1; o <= l; ++o)
          f[Ee[o] >> u] = c;
  } else
    for (f = new Y(r), i = 0; i < r; ++i)
      s[i] && (f[i] = Ee[a[s[i] - 1]++] >> 15 - s[i]);
  return f;
}, ne = new A(288);
for (var w = 0; w < 144; ++w)
  ne[w] = 8;
for (var w = 144; w < 256; ++w)
  ne[w] = 9;
for (var w = 256; w < 280; ++w)
  ne[w] = 7;
for (var w = 280; w < 288; ++w)
  ne[w] = 8;
var et = new A(32);
for (var w = 0; w < 32; ++w)
  et[w] = 5;
var bt = /* @__PURE__ */ se(ne, 9, 1), At = /* @__PURE__ */ se(et, 5, 1), ke = function(s) {
  for (var t = s[0], e = 1; e < s.length; ++e)
    s[e] > t && (t = s[e]);
  return t;
}, P = function(s, t, e) {
  var r = t / 8 | 0;
  return (s[r] | s[r + 1] << 8) >> (t & 7) & e;
}, Se = function(s, t) {
  var e = t / 8 | 0;
  return (s[e] | s[e + 1] << 8 | s[e + 2] << 16) >> (t & 7);
}, Bt = function(s) {
  return (s + 7) / 8 | 0;
}, Ge = function(s, t, e) {
  return (t == null || t < 0) && (t = 0), (e == null || e > s.length) && (e = s.length), new A(s.subarray(t, e));
}, jt = [
  "unexpected EOF",
  "invalid block type",
  "invalid length/literal",
  "invalid distance",
  "stream finished",
  "no stream handler",
  ,
  "no callback",
  "invalid UTF-8 data",
  "extra field too long",
  "date not in range 1980-2099",
  "filename too long",
  "stream finishing",
  "invalid zip data"
  // determined by unknown compression method
], G = function(s, t, e) {
  var r = new Error(t || jt[s]);
  if (r.code = s, Error.captureStackTrace && Error.captureStackTrace(r, G), !e)
    throw r;
  return r;
}, Gt = function(s, t, e, r) {
  var i = s.length, n = r ? r.length : 0;
  if (!i || t.f && !t.l)
    return e || new A(0);
  var a = !e, f = a || t.i != 2, u = t.i;
  a && (e = new A(i * 3));
  var c = function($e) {
    var De = e.length;
    if ($e > De) {
      var Ue = new A(Math.max(De * 2, $e));
      Ue.set(e), e = Ue;
    }
  }, h = t.f || 0, o = t.p || 0, l = t.b || 0, p = t.l, y = t.d, x = t.m, I = t.n, k = i * 8;
  do {
    if (!p) {
      h = P(s, o, 1);
      var T = P(s, o + 1, 3);
      if (o += 3, T)
        if (T == 1)
          p = bt, y = At, x = 9, I = 5;
        else if (T == 2) {
          var N = P(s, o, 31) + 257, W = P(s, o + 10, 15) + 4, ee = N + P(s, o + 5, 31) + 1;
          o += 14;
          for (var v = new A(ee), M = new A(19), S = 0; S < W; ++S)
            M[xt[S]] = P(s, o + S * 3, 7);
          o += W * 3;
          for (var _e = ke(M), at = (1 << _e) - 1, ot = se(M, _e, 1), S = 0; S < ee; ) {
            var qe = ot[P(s, o, at)];
            o += qe & 15;
            var R = qe >> 4;
            if (R < 16)
              v[S++] = R;
            else {
              var J = 0, ae = 0;
              for (R == 16 ? (ae = 3 + P(s, o, 3), o += 2, J = v[S - 1]) : R == 17 ? (ae = 3 + P(s, o, 7), o += 3) : R == 18 && (ae = 11 + P(s, o, 127), o += 7); ae--; )
                v[S++] = J;
            }
          }
          var Oe = v.subarray(0, N), C = v.subarray(N);
          x = ke(Oe), I = ke(C), p = se(Oe, x, 1), y = se(C, I, 1);
        } else
          G(1);
      else {
        var R = Bt(o) + 4, K = s[R - 4] | s[R - 3] << 8, L = R + K;
        if (L > i) {
          u && G(0);
          break;
        }
        f && c(l + K), e.set(s.subarray(R, L), l), t.b = l += K, t.p = o = L * 8, t.f = h;
        continue;
      }
      if (o > k) {
        u && G(0);
        break;
      }
    }
    f && c(l + 131072);
    for (var ut = (1 << x) - 1, ct = (1 << I) - 1, pe = o; ; pe = o) {
      var J = p[Se(s, o) & ut], F = J >> 4;
      if (o += J & 15, o > k) {
        u && G(0);
        break;
      }
      if (J || G(2), F < 256)
        e[l++] = F;
      else if (F == 256) {
        pe = o, p = null;
        break;
      } else {
        var Te = F - 254;
        if (F > 264) {
          var S = F - 257, te = Ye[S];
          Te = P(s, o, (1 << te) - 1) + Ze[S], o += te;
        }
        var we = y[Se(s, o) & ct], ge = we >> 4;
        we || G(3), o += we & 15;
        var C = Et[ge];
        if (ge > 3) {
          var te = Xe[ge];
          C += Se(s, o) & (1 << te) - 1, o += te;
        }
        if (o > k) {
          u && G(0);
          break;
        }
        f && c(l + 131072);
        var Le = l + Te;
        if (l < C) {
          var Ce = n - C, lt = Math.min(C, Le);
          for (Ce + l < 0 && G(3); l < lt; ++l)
            e[l] = r[Ce + l];
        }
        for (; l < Le; ++l)
          e[l] = e[l - C];
      }
    }
    t.l = p, t.p = pe, t.b = l, t.f = h, p && (h = 1, t.m = x, t.d = y, t.n = I);
  } while (!h);
  return l != e.length && a ? Ge(e, 0, l) : e.subarray(0, l);
}, Pt = /* @__PURE__ */ new A(0), O = function(s, t) {
  return s[t] | s[t + 1] << 8;
}, _ = function(s, t) {
  return (s[t] | s[t + 1] << 8 | s[t + 2] << 16 | s[t + 3] << 24) >>> 0;
}, xe = function(s, t) {
  return _(s, t) + _(s, t + 4) * 4294967296;
};
function _t(s, t) {
  return Gt(s, { i: 2 }, t && t.out, t && t.dictionary);
}
var be = typeof TextDecoder < "u" && /* @__PURE__ */ new TextDecoder(), qt = 0;
try {
  be.decode(Pt, { stream: !0 }), qt = 1;
} catch {
}
var Ot = function(s) {
  for (var t = "", e = 0; ; ) {
    var r = s[e++], i = (r > 127) + (r > 223) + (r > 239);
    if (e + i > s.length)
      return { s: t, r: Ge(s, e - 1) };
    i ? i == 3 ? (r = ((r & 15) << 18 | (s[e++] & 63) << 12 | (s[e++] & 63) << 6 | s[e++] & 63) - 65536, t += String.fromCharCode(55296 | r >> 10, 56320 | r & 1023)) : i & 1 ? t += String.fromCharCode((r & 31) << 6 | s[e++] & 63) : t += String.fromCharCode((r & 15) << 12 | (s[e++] & 63) << 6 | s[e++] & 63) : t += String.fromCharCode(r);
  }
};
function Tt(s, t) {
  if (t) {
    for (var e = "", r = 0; r < s.length; r += 16384)
      e += String.fromCharCode.apply(null, s.subarray(r, r + 16384));
    return e;
  } else {
    if (be)
      return be.decode(s);
    var i = Ot(s), n = i.s, e = i.r;
    return e.length && G(8), n;
  }
}
var Lt = function(s, t) {
  return t + 30 + O(s, t + 26) + O(s, t + 28);
}, Ct = function(s, t, e) {
  var r = O(s, t + 28), i = Tt(s.subarray(t + 46, t + 46 + r), !(O(s, t + 8) & 2048)), n = t + 46 + r, a = _(s, t + 20), f = e && a == 4294967295 ? $t(s, n) : [a, _(s, t + 24), _(s, t + 42)], u = f[0], c = f[1], h = f[2];
  return [O(s, t + 10), u, c, i, n + O(s, t + 30) + O(s, t + 32), h];
}, $t = function(s, t) {
  for (; O(s, t) != 1; t += 4 + O(s, t + 2))
    ;
  return [xe(s, t + 12), xe(s, t + 4), xe(s, t + 20)];
};
function Dt(s, t) {
  for (var e = {}, r = s.length - 22; _(s, r) != 101010256; --r)
    (!r || s.length - r > 65558) && G(13);
  var i = O(s, r + 8);
  if (!i)
    return {};
  var n = _(s, r + 16), a = n == 4294967295 || i == 65535;
  if (a) {
    var f = _(s, r - 12);
    a = _(s, f) == 101075792, a && (i = _(s, f + 32), n = _(s, f + 48));
  }
  for (var u = t && t.filter, c = 0; c < i; ++c) {
    var h = Ct(s, n, a), o = h[0], l = h[1], p = h[2], y = h[3], x = h[4], I = h[5], k = Lt(s, I);
    n = x, (!u || u({
      name: y,
      size: l,
      originalSize: p,
      compression: o
    })) && (o ? o == 8 ? e[y] = _t(s.subarray(k, k + l), { out: new A(p) }) : G(14, "unknown compression type " + o) : e[y] = Ge(s, k, k + l));
  }
  return e;
}
class tt extends de {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://www.browserstack.com",
      usernameOptional: !0
    });
    B(this, "authToken");
    const r = (e == null ? void 0 : e.key) ?? re.BROWSERSTACK_KEY;
    if (typeof r != "string" || !r.trim().length)
      throw new d("Missing options.key");
    this.authToken = r;
  }
  /**
   * Retrieves a list of recent Local binary instances from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of active Local instances.
   */
  getBinaryInstances(e, r) {
    return this.makeGetRequest("/local/v1/list", {
      ...r,
      params: {
        query: {
          ...e,
          auth_token: this.authToken
        }
      }
    }).then((i) => i.instances);
  }
  /**
   * Retrieves details of a Local binary instance from the server.
   *
   * @param localInstanceId The ID of the local binary instance to retrieve.
   * @param query Optional query parameters for the request.
   * @param options Optional fetch options for the request.
   * @returns A promise that resolves to the retrieved local binary instance.
   * @throws {BrowserStackError} If no local binary instance is found with the specified ID.
   */
  getBinaryInstance(e, r, i) {
    return this.makeGetRequest("/local/v1/{localInstanceId}", {
      ...i,
      params: {
        path: {
          localInstanceId: e
        },
        query: {
          ...r,
          auth_token: this.authToken
        }
      }
    }).then((n) => {
      if (!n.instances.length)
        throw new d(
          `No Local binary instance found with id "${e}"`
        );
      return n.instances[0];
    });
  }
  /**
   * Disconnects a binary instance.
   *
   * @param localInstanceId - The ID of the local binary instance to disconnect.
   * @param query - Optional query parameters for the request.
   * @param options - Optional API fetch options.
   * @returns A promise that resolves to a string representing the message from the server.
   */
  disconnectBinaryInstance(e, r, i) {
    return this.makeDeleteRequest("/local/v1/{localInstanceId}", {
      ...i,
      params: {
        path: {
          localInstanceId: e
        },
        query: {
          ...r,
          auth_token: this.authToken
        }
      }
    }).then((n) => n.message);
  }
  /**
   * Downloads the BrowserStackLocal binary for the specified operating system architecture and saves it to the specified file path.
   * Note that the file is downloaded to memory for the unzip operation.
   * If the file is large, this method may fail with an out of memory error.
   * This method is intended for use in Node.js environments and will fail in the browser.
   *
   * @internal
   * @param osArch - The operating system architecture for which to download the binary.
   * @param dirPath - The file path where the binary will be saved.
   * @param filenamePrefix - The prefix for the downloaded binary file name inside the ZIP file. Default is "BrowserStackLocal".
   * @param fileMode - The file mode to set for the downloaded binary file. Default is 0o755.
   * @param options - Additional options for the API fetch request.
   * @returns A Promise that resolves when the binary is successfully downloaded and saved.
   */
  downloadBinary(e, r = "BrowserStackLocal", i) {
    return this.sdk.GET("/browserstack-local/BrowserStackLocal-{osArch}.zip", {
      ...i,
      params: {
        path: {
          osArch: e
        }
      },
      parseAs: "arrayBuffer"
    }).then(({ data: n }) => {
      if (!n)
        throw new d(
          `Failed to download BrowserStackLocal-${e}.zip: Unexpected response.`
        );
      const a = Dt(new Uint8Array(n), {
        filter: (c) => c.name.startsWith(r)
      }), f = Object.keys(a);
      if (!f.length)
        throw new d(
          `Local binary not found in BrowserStackLocal-${e}.zip`
        );
      return { content: a[f[0]], filename: f[0] };
    }).catch((n) => {
      throw n instanceof d ? n : new d(
        `Failed to write local binary to disk: ${n.message}: ${n.stack}`
      );
    });
  }
}
const le = class le extends de {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://www.browserstack.com"
    });
  }
  /**
   * Retrieves the list of available browsers for taking screenshots.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getBrowsers(t) {
    return this.makeGetRequest("/screenshots/browsers.json", t);
  }
  /**
   * Creates a new screenshots job.
   * @param body - The request body for creating the job.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  createJob(t, e) {
    return this.makePostRequest("/screenshots", {
      ...e,
      body: t
    }).then((r) => ({
      ...r,
      id: r.job_id
    }));
  }
  /**
   * Retrieves the details of a screenshots job.
   * @param jobId - The ID of the job to retrieve.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getJob(t, e) {
    return this.makeGetRequest("/screenshots/{jobId}.json", {
      ...e,
      params: {
        path: {
          jobId: t
        }
      }
    }).then((r) => ({
      ...r,
      id: r.id ?? r.job_id
    }));
  }
  /**
   * Tracks the progress of a screenshot job and retrieves the screenshots associated with it.
   *
   * @param jobId - The ID of the job to track.
   * @param onScreenshot - Optional callback function that will be called when a new screenshot is added to the result.
   * @param pollInterval - The interval (in milliseconds) at which the job status should be polled. Default is 10000ms.
   * @returns A promise that resolves with an array of screenshots when the job is completed.
   */
  trackJob(t, e, r, i = 1e4) {
    return new Promise((n, a) => {
      const f = /* @__PURE__ */ new Map();
      let u;
      const c = (o) => {
        var l;
        clearInterval(h), (l = u == null ? void 0 : u.abort) == null || l.call(u), o ? a(
          o instanceof d ? o : new d(o.message, o)
        ) : n(Array.from(f.values()));
      }, h = setInterval(async () => {
        u = r != null && r.signal ? void 0 : new AbortController();
        const o = await this.getJob(t, {
          ...r,
          signal: (r == null ? void 0 : r.signal) ?? (u == null ? void 0 : u.signal)
        }).catch(c);
        if (!o)
          return;
        const l = o.screenshots ?? [];
        for (const p of l)
          le.jobCompleteStates.includes(p.state) && (f.has(p.id) || f.set(p.id, p), await (e == null ? void 0 : e(p)));
        (o.state === "done" || l.length === f.size) && c();
      }, i);
    });
  }
  /**
   * Launches a screenshots job with the specified parameters.
   *
   * @param body - The request body for creating the screenshots job.
   * @param onScreenshot - Optional callback function to be called when a screenshot is available.
   * @param options - Optional options for the API fetch and job tracking, including pollInterval.
   * @returns A promise that resolves to the result of the job tracking.
   */
  async launch(t, e, r) {
    const { pollInterval: i, ...n } = r ?? {}, { id: a } = await this.createJob(t, n);
    return this.trackJob(a, e, void 0, i);
  }
};
/**
 * @internal
 */
B(le, "jobCompleteStates", ["done", "error"]);
let Ae = le;
const Ut = {
  AutomateClient: kt,
  ScreenshotsClient: Ae,
  AppAutomateClient: mt,
  JSTestingClient: He,
  /**
   * Backwards compatibility alias for {@link JSTestingClient}.
   */
  Client: He,
  LocalTestingClient: tt
}, X = [];
X.push("SIGHUP", "SIGINT", "SIGTERM");
process.platform !== "win32" && X.push(
  "SIGALRM",
  "SIGABRT",
  "SIGVTALRM",
  "SIGXCPU",
  "SIGXFSZ",
  "SIGUSR2",
  "SIGTRAP",
  "SIGSYS",
  "SIGQUIT",
  "SIGIOT"
  // should detect profiler and enable/disable accordingly.
  // see #21
  // 'SIGPROF'
);
process.platform === "linux" && X.push("SIGIO", "SIGPOLL", "SIGPWR", "SIGSTKFLT");
const ue = (s) => !!s && typeof s == "object" && typeof s.removeListener == "function" && typeof s.emit == "function" && typeof s.reallyExit == "function" && typeof s.listeners == "function" && typeof s.kill == "function" && typeof s.pid == "number" && typeof s.on == "function", Re = Symbol.for("signal-exit emitter"), Ie = globalThis, Wt = Object.defineProperty.bind(Object);
class Mt {
  constructor() {
    B(this, "emitted", {
      afterExit: !1,
      exit: !1
    });
    B(this, "listeners", {
      afterExit: [],
      exit: []
    });
    B(this, "count", 0);
    B(this, "id", Math.random());
    if (Ie[Re])
      return Ie[Re];
    Wt(Ie, Re, {
      value: this,
      writable: !1,
      enumerable: !1,
      configurable: !1
    });
  }
  on(t, e) {
    this.listeners[t].push(e);
  }
  removeListener(t, e) {
    const r = this.listeners[t], i = r.indexOf(e);
    i !== -1 && (i === 0 && r.length === 1 ? r.length = 0 : r.splice(i, 1));
  }
  emit(t, e, r) {
    if (this.emitted[t])
      return !1;
    this.emitted[t] = !0;
    let i = !1;
    for (const n of this.listeners[t])
      i = n(e, r) === !0 || i;
    return t === "exit" && (i = this.emit("afterExit", e, r) || i), i;
  }
}
class rt {
}
const Ht = (s) => ({
  onExit(t, e) {
    return s.onExit(t, e);
  },
  load() {
    return s.load();
  },
  unload() {
    return s.unload();
  }
});
class zt extends rt {
  onExit() {
    return () => {
    };
  }
  load() {
  }
  unload() {
  }
}
var fe, b, g, V, Q, z, D, he, st, me, it;
class Kt extends rt {
  constructor(e) {
    super();
    q(this, he);
    q(this, me);
    // "SIGHUP" throws an `ENOSYS` error on Windows,
    // so use a supported signal instead
    /* c8 ignore start */
    q(this, fe, Be.platform === "win32" ? "SIGINT" : "SIGHUP");
    /* c8 ignore stop */
    q(this, b, new Mt());
    q(this, g, void 0);
    q(this, V, void 0);
    q(this, Q, void 0);
    q(this, z, {});
    q(this, D, !1);
    H(this, g, e), H(this, z, {});
    for (const r of X)
      m(this, z)[r] = () => {
        const i = m(this, g).listeners(r);
        let { count: n } = m(this, b);
        const a = e;
        if (typeof a.__signal_exit_emitter__ == "object" && typeof a.__signal_exit_emitter__.count == "number" && (n += a.__signal_exit_emitter__.count), i.length === n) {
          this.unload();
          const f = m(this, b).emit("exit", null, r), u = r === "SIGHUP" ? m(this, fe) : r;
          f || e.kill(e.pid, u);
        }
      };
    H(this, Q, e.reallyExit), H(this, V, e.emit);
  }
  onExit(e, r) {
    if (!ue(m(this, g)))
      return () => {
      };
    m(this, D) === !1 && this.load();
    const i = r != null && r.alwaysLast ? "afterExit" : "exit";
    return m(this, b).on(i, e), () => {
      m(this, b).removeListener(i, e), m(this, b).listeners.exit.length === 0 && m(this, b).listeners.afterExit.length === 0 && this.unload();
    };
  }
  load() {
    if (!m(this, D)) {
      H(this, D, !0), m(this, b).count += 1;
      for (const e of X)
        try {
          const r = m(this, z)[e];
          r && m(this, g).on(e, r);
        } catch {
        }
      m(this, g).emit = (e, ...r) => ye(this, me, it).call(this, e, ...r), m(this, g).reallyExit = (e) => ye(this, he, st).call(this, e);
    }
  }
  unload() {
    m(this, D) && (H(this, D, !1), X.forEach((e) => {
      const r = m(this, z)[e];
      if (!r)
        throw new Error("Listener not defined for signal: " + e);
      try {
        m(this, g).removeListener(e, r);
      } catch {
      }
    }), m(this, g).emit = m(this, V), m(this, g).reallyExit = m(this, Q), m(this, b).count -= 1);
  }
}
fe = new WeakMap(), b = new WeakMap(), g = new WeakMap(), V = new WeakMap(), Q = new WeakMap(), z = new WeakMap(), D = new WeakMap(), he = new WeakSet(), st = function(e) {
  return ue(m(this, g)) ? (m(this, g).exitCode = e || 0, m(this, b).emit("exit", m(this, g).exitCode, null), m(this, Q).call(m(this, g), m(this, g).exitCode)) : 0;
}, me = new WeakSet(), it = function(e, ...r) {
  const i = m(this, V);
  if (e === "exit" && ue(m(this, g))) {
    typeof r[0] == "number" && (m(this, g).exitCode = r[0]);
    const n = i.call(m(this, g), e, ...r);
    return m(this, b).emit("exit", m(this, g).exitCode, null), n;
  } else
    return i.call(m(this, g), e, ...r);
};
const Be = globalThis.process, {
  /**
   * Called when the process is exiting, whether via signal, explicit
   * exit, or running out of stuff to do.
   *
   * If the global process object is not suitable for instrumentation,
   * then this will be a no-op.
   *
   * Returns a function that may be used to unload signal-exit.
   */
  onExit: Nt,
  /**
   * Load the listeners.  Likely you never need to call this, unless
   * doing a rather deep integration with signal-exit functionality.
   * Mostly exposed for the benefit of testing.
   *
   * @internal
   */
  load: cr,
  /**
   * Unload the listeners.  Likely you never need to call this, unless
   * doing a rather deep integration with signal-exit functionality.
   * Mostly exposed for the benefit of testing.
   *
   * @internal
   */
  unload: lr
} = Ht(ue(Be) ? new Kt(Be) : new zt()), U = {};
function Jt(s) {
  return s + "." + Ne(6).toString("hex");
}
function Ft(s) {
  return () => {
    const t = typeof s == "function" ? s() : s;
    if (t)
      try {
        E.unlinkSync(t);
      } catch {
      }
  };
}
function Yt(s) {
  return new Promise((t) => {
    U[s] || (U[s] = []), U[s].push(t), U[s].length === 1 && t();
  });
}
function ze(s) {
  const t = typeof s == "object" && s && "code" in s ? s.code : void 0;
  return t === "ENOSYS" || (!process.getuid || process.getuid() !== 0) && (t === "EINVAL" || t === "EPERM");
}
async function Xt(s, t, e = {}) {
  typeof e == "string" && (e = { encoding: e });
  let r, i;
  const n = Nt(Ft(() => i)), a = dt.resolve(s);
  try {
    await Yt(a);
    const f = await j(E.realpath)(s).catch(
      () => s
    );
    if (i = Jt(f), !e.mode || !e.chown) {
      const u = await j(E.stat)(f).catch(
        () => {
        }
      );
      u && (e.mode == null && (e.mode = u.mode), e.chown == null && process.getuid && (e.chown = { uid: u.uid, gid: u.gid }));
    }
    r = await j(E.open)(i, "w", e.mode), e.tmpfileCreated && await e.tmpfileCreated(i), Buffer.isBuffer(t) ? await j(E.write)(r, t, 0, t.length, 0) : t != null && await j(E.write)(
      r,
      String(t),
      0,
      e.encoding || "utf8"
    ), e.fsync !== !1 && await j(E.fsync)(r), await j(E.close)(r), r = void 0, e.chown && await j(E.chown)(
      i,
      e.chown.uid,
      e.chown.gid
    ).catch((u) => {
      if (!ze(u))
        throw u;
    }), e.mode && await j(E.chmod)(i, e.mode).catch((u) => {
      if (!ze(u))
        throw u;
    }), await j(E.rename)(i, f);
  } finally {
    r && await j(E.close)(r).catch(
      /* istanbul ignore next */
      () => {
      }
    ), n(), i && await j(E.unlink)(i).catch(() => {
    }), U[a].shift(), U[a].length > 0 ? U[a][0]() : delete U[a];
  }
}
async function Ke(s, t = "BrowserStackLocal") {
  const e = await Qt(s), i = await nt() === "win32" ? `${t}.exe` : t, n = je(e, i);
  if (!await ce(n, Z.R_OK | Z.X_OK))
    throw new d(`Missing or inaccessible file: ${n}`);
  return n;
}
async function ce(s, t = Z.R_OK) {
  if (typeof s != "string" || !s.trim().length)
    return !1;
  const e = await ie(s).catch(
    (i) => i.code === "ENOENT" ? null : i
  ), r = t & 448;
  return !(!e || !e.isFile() || e.mode & r);
}
async function Vt(s, t = Z.R_OK) {
  if (typeof s != "string" || !s.trim().length)
    return !1;
  const e = await ie(s).catch(
    (i) => i.code === "ENOENT" ? null : i
  ), r = t & 448;
  return !(!e || !e.isDirectory() || e.mode & r);
}
async function Qt(s, t = 493, e) {
  try {
    const r = Je(s), i = await ie(r).catch(async (a) => {
      if (a.code === "ENOENT")
        return await wt(r, { recursive: !0, mode: t }), ie(r);
      throw a;
    }), n = (e ?? Z.R_OK | Z.W_OK) & 448;
    return i && i.mode & n && await gt(r, t), r;
  } catch (r) {
    throw r instanceof Error ? new d(
      `Missing or inaccessible directory: ${s}`,
      r
    ) : r;
  }
}
async function nt() {
  if (["x64", "ia32"].includes(oe))
    switch (We) {
      case "darwin":
        if (oe === "x64")
          return "darwin-x64";
        break;
      case "win32":
      case "cygwin":
        return "win32";
      case "linux":
        if (oe === "ia32")
          return "linux-ia32";
        try {
          if (pt("ldd", ["--version"]).stderr.toString("utf8").indexOf("musl") !== -1)
            return "alpine";
        } catch {
        }
        return "linux-x64";
    }
  throw new d(
    `Unsupported platform/arch: ${We}/${oe}`
  );
}
async function Zt(s, t, e, r) {
  const i = je(Je(s), t);
  try {
    return await Xt(i, Buffer.from(e), { mode: r }), i;
  } catch (n) {
    try {
      (await ie(i)).isFile() && await Fe(i);
    } catch {
    }
    throw n;
  }
}
class Pe extends tt {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    var i, n;
    super(e);
    B(this, "localIdentifier");
    B(this, "child", {
      pid: void 0,
      args: []
    });
    B(this, "commandTimeoutMs");
    B(this, "binHome");
    /**
     * The last state of the BrowserStackLocal daemon command.
     * @public
     */
    B(this, "state", "stopped");
    this.options = e;
    const r = (e == null ? void 0 : e.localIdentifier) ?? ((n = (i = re.BROWSERSTACK_LOCAL_ID ?? re.BROWSERSTACK_LOCAL_IDENTIFIER) == null ? void 0 : i.trim) == null ? void 0 : n.call(i)) ?? Ne(16).toString("hex");
    if (typeof r != "string" || !r.trim().length)
      throw new d("Missing options.localIdentifier.id");
    this.localIdentifier = r, this.commandTimeoutMs = (e == null ? void 0 : e.commandTimeoutMs) ?? 1e4, this.binHome = this.getBinHome();
  }
  /**
   * Retrieves the version of the local testing binary.
   * @returns A promise that resolves to the version string.
   */
  async version() {
    const e = await this.ensureBinaryExists();
    return new Promise((r, i) => {
      var c, h, o, l, p, y, x, I, k, T;
      const n = Me.spawnSync(e, ["--version"], {
        timeout: this.commandTimeoutMs,
        cwd: this.binHome,
        windowsHide: !0
      }), a = (l = (o = (h = (c = n.stdout) == null ? void 0 : c.toString) == null ? void 0 : h.call(c, "utf8")) == null ? void 0 : o.trim) == null ? void 0 : l.call(o), f = (y = (p = a == null ? void 0 : a.match(/\s+version\s+(.*)$/i)) == null ? void 0 : p[1]) == null ? void 0 : y.trim();
      if (typeof f == "string")
        return r(f);
      const u = (T = (k = (I = (x = n.stderr) == null ? void 0 : x.toString) == null ? void 0 : I.call(x, "utf8")) == null ? void 0 : k.trim) == null ? void 0 : T.call(k);
      i(
        new d(
          `Failed to get version: ${u ?? a} (status=${n.status})`
        )
      );
    });
  }
  /**
   * Starts the BrowserStackLocal daemon.
   *
   * @returns A promise that resolves to a string if the binary starts successfully, or undefined if there is an error.
   */
  async start() {
    let e;
    return await this.runDaemonCommand({
      action: "start",
      initialState: "starting",
      successState: "started",
      isSuccess: (r, i, n) => {
        const a = i === "connected";
        return e ?? (e = n), a;
      }
    }).catch((r) => {
      throw e && Object.assign(r, { message: e }), r;
    }), e;
  }
  /**
   * Stops the BrowserStackLocal daemon.
   *
   * @returns A promise that resolves to a string if the daemon stops successfully, or undefined otherwise.
   */
  async stop() {
    let e;
    return await this.runDaemonCommand({
      action: "stop",
      initialState: "stopping",
      successState: "stopped",
      isSuccess: (r, i, n) => {
        var f, u, c;
        return e ?? (e = n), i === "success" && ((c = (u = (f = n == null ? void 0 : n.toLowerCase) == null ? void 0 : f.call(n)) == null ? void 0 : u.includes) == null ? void 0 : c.call(u, "stopped successfully")) === !0;
      }
    }).catch((r) => {
      throw e && Object.assign(r, { message: e }), r;
    }), e;
  }
  /**
   * @internal
   */
  async runDaemonCommand(e, r = this.commandTimeoutMs, i = this.binHome, n = !1) {
    const a = {
      state: this.state,
      pid: this.child.pid,
      args: this.child.args
    }, f = () => {
      this.state = a.state, this.child.pid = a.pid, this.child.args = a.args;
    }, u = (l) => {
      throw f(), l;
    };
    if (n)
      try {
        await Fe(await Ke(i));
      } catch {
      }
    const c = await this.ensureBinaryExists().catch(u), h = async (l) => (f(), n ? Promise.reject(
      new d(`Failed to run binary: ${c}`, l)
    ) : this.runDaemonCommand(e, r, i, !0)), o = await Pe.resolveArgs(
      this.authToken,
      this.localIdentifier,
      e.action,
      this.options
    );
    return new Promise((l, p) => {
      var k, T, R, K, L, N, W, ee;
      this.state = e.initialState;
      const y = Me.spawnSync(c, o, {
        timeout: r,
        cwd: i,
        windowsHide: !0
      });
      if (y.error) {
        const v = new d(y.error.message, y.error);
        return v.code === "EACCES" ? h(v).then(l).catch(p) : p(v);
      }
      const x = (K = (R = (T = (k = y.stdout) == null ? void 0 : k.toString) == null ? void 0 : T.call(k, "utf8")) == null ? void 0 : R.trim) == null ? void 0 : K.call(R);
      if (x)
        try {
          const v = JSON.parse(x);
          if (v && typeof v == "object") {
            const { state: M, message: S } = this.parseOutput(v);
            if (e.isSuccess(v, M, S))
              return this.state = e.successState, e.action === "start" ? (this.child.pid = v.pid ?? y.pid, this.child.args = o.slice(2)) : e.action === "stop" && (this.child.pid = void 0, this.child.args = []), l();
          }
        } catch {
        }
      const I = (ee = (W = (N = (L = y.stderr) == null ? void 0 : L.toString) == null ? void 0 : N.call(L, "utf8")) == null ? void 0 : W.trim) == null ? void 0 : ee.call(W);
      if (I)
        try {
          const v = JSON.parse(I);
          if (v && typeof v == "object") {
            const { state: M, message: S } = this.parseOutput(v);
            if (S)
              return p(new d(`${S} state=${M}`));
          }
        } catch {
          return h(new Error("Invalid binary: stderr")).then(l).catch(p);
        }
      return p(new d(I ?? x));
    }).catch(u);
  }
  /**
   * @internal
   */
  static async resolveArgs(e, r, i, n) {
    if (typeof e != "string" || !e.trim().length)
      throw new d("Required: key");
    if (typeof r != "string" || !r.trim().length)
      throw new d("Required: localIdentifier");
    const a = [
      "--key",
      e.trim(),
      "--local-identifier",
      r.trim(),
      "--daemon",
      i
    ];
    if (!n)
      return a;
    const f = async ({ rootCA: c }) => {
      c && "useSystem" in c && c.useSystem === !0 && a.push("--use-system-installed-ca"), c && "path" in c && c.path && await ce(c.path) && a.push("--use-ca-certificate", c.path);
    };
    if ((n == null ? void 0 : n.disableAPILogging) !== !0 && a.push("--enable-logging-for-api"), n.forceLocal === !0)
      a.push("--force-local");
    else if (n.only) {
      const c = n.only.map(
        ({ host: h, port: o, ssl: l }) => `${h},${o},${l ? 1 : 0}`
      );
      a.push("--only", c.join(","));
    }
    if ("folder" in n && await Vt(n.folder))
      a.push("--folder", n.folder);
    else if ("localProxy" in n && n.localProxy) {
      const {
        host: c,
        port: h,
        auth: { username: o, password: l } = {
          username: void 0,
          password: void 0
        }
      } = n.localProxy;
      a.push("--local-proxy-host", c.trim()), h && a.push("--local-proxy-port", `${h}`), o && l && (a.push("--local-proxy-user", o.trim()), a.push("--local-proxy-pass", l.trim())), await f(n.localProxy);
    }
    const u = n == null ? void 0 : n.proxy;
    if (u)
      if (typeof u == "string")
        if (await ce(u))
          a.push("--proxy-pac", u);
        else
          throw new d(`Invalid proxy pac file: ${u}`);
      else {
        const {
          host: c,
          port: h,
          auth: { username: o, password: l } = {
            username: void 0,
            password: void 0
          },
          force: p
        } = u;
        a.push("--proxy-host", c.trim()), h && a.push("--proxy-port", `${h}`), o && l && (a.push("--proxy-user", o.trim()), a.push("--proxy-pass", l.trim())), p && a.push("--force-proxy"), await f(u);
      }
    if (n.onlyAutomate === !0 && a.push("--only-automate"), n.debug) {
      const { level: c, logFile: h } = n.debug;
      c && a.push("--verbose", `${c}`), h && a.push("--log-file", h);
    }
    if (n.timeout && a.push("--timeout", `${n.timeout}`), n.parallelRuns && a.push("--parallel-runs", `${n.parallelRuns}`), n.hosts) {
      const { include: c, exclude: h } = n.hosts;
      Array.isArray(c) && c.length && a.push("--include-hosts", ...c), Array.isArray(h) && h.length && a.push("--exclude-hosts", ...h);
    }
    return a.concat(n.more ?? []);
  }
  get pid() {
    var e;
    return (e = this.child) == null ? void 0 : e.pid;
  }
  get args() {
    var e, r;
    return (e = this.child) != null && e.args ? Array.from((r = this.child) == null ? void 0 : r.args) : [];
  }
  /**
   * @internal
   */
  parseOutput(e) {
    let r, i, n;
    return typeof e.status == "string" && (r = e.status.trim()), typeof e.state == "string" && (r = e.state.trim()), typeof e.pid == "string" && (i = e.pid.trim()), "message" in e && e.message && (typeof e.message == "string" ? n = e.message.trim() : typeof e.message == "object" && (n = "message" in e.message && typeof e.message.message == "string" ? e.message.message.trim() : void 0)), { state: r, pid: i, message: n };
  }
  /**
   * Returns the default home directory for the BrowserStack binary.
   * If the user's home directory is available, it will be used.
   * Otherwise, the system's temporary directory will be used.
   * @returns The default home directory path.
   *
   * @internal
   */
  defaultBinHome() {
    return je(vt() ?? yt(), ".browserstack");
  }
  /**
   * @internal
   */
  getBinHome() {
    var r;
    const e = ((r = this.options) == null ? void 0 : r.binHome) ?? re.BROWSERSTACK_LOCAL_BINARY_HOME ?? re.BROWSERSTACK_LOCAL_BINARY_PATH ?? this.defaultBinHome();
    if (typeof e != "string" || !e.trim().length)
      throw new d("Missing options.binHome");
    return e.trim();
  }
  /**
   * @internal
   */
  async ensureBinaryExists() {
    try {
      const r = await Ke(this.binHome);
      if (await ce(r))
        return r;
    } catch {
    }
    const e = await nt();
    if (!e)
      throw new d(`Unsupported platform: ${e}`);
    try {
      const { content: r, filename: i } = await this.downloadBinary(e);
      return await Zt(this.binHome, i, r, 493);
    } catch (r) {
      throw r instanceof d ? r : r instanceof Error ? new d(
        `Failed to download binary: ${r.message}`,
        r
      ) : new d(`Failed to download binary: ${r}`);
    }
  }
}
const fr = {
  ...Ut,
  LocalTestingBinary: Pe
};
export {
  kt as A,
  fr as B,
  He as J,
  Pe as L,
  Ae as S,
  tt as a,
  Qt as e,
  Nt as o,
  Xt as w
};
