import { operations } from './generated/openapi.ts';
export declare function binaryPath(binHome: string, filename?: string): Promise<string>;
export declare function fileExists(filePath: string, fileFlags?: number): Promise<boolean>;
export declare function dirExists(dirPath: string, dirFlags?: number): Promise<boolean>;
export declare function ensureDirExists(binHome: string, dirMode?: number, dirFlags?: number): Promise<string>;
export declare function currentOSArch(): Promise<operations["downloadLocalBinary"]["parameters"]["path"]["osArch"] | undefined>;
export declare function saveFile(dirPath: string, filename: string, content: Uint8Array, fileMode: number): Promise<string>;
/**
 * Finds the package ID by searching for the nearest package.json file in the current working directory and its parent directories.
 *
 * @param includeVersion Whether to include the version in the package ID.
 * @param maxDepth The maximum depth to search for the package.json file.
 * @returns A Promise that resolves to the package ID (name with optional version) if found, or undefined if not found.
 *
 * @internal
 */
export declare function findPackageId(includeVersion?: boolean, maxDepth?: number): Promise<string | undefined>;
